/****************************************************************************
CREATE DATABASE FUNCTIONS for basic WebCenter16.1 functionality.
****************************************************************************/
			
/**************************************************************************************
* keyword: build
*
* Oracle version 8i,9i
* From a command line, run:
* 	sqlplus "sys/<sysPWD>@<net-Service-name> as sysdba" @oracle_functions161.sql WEBCENTER <varchar type>
* egs
*	sqlplus "sys/change_on_install@wc as sysdba" @oracle_functions161.sql WEBCENTER varchar2
*	sqlplus "sys/change_on_install@wc as sysdba" @oracle_functions161.sql WEBCENTER nvarchar2
* where
*	<sysPWD> is the sys user's password
* 	<net-Service-name> is the network service name setup via the Net Configuration utility
*	WEBCENTER is the shema owner is represented as &1 in the script
*	<varchar type> is either varchar2 or nvarchar2 and is &2 in the script
*
**************************************************************************************/

create or replace
FUNCTION "&1".figureOutTaskName(projectID &2, taskName &2) 
RETURN number
IS 
  nextNumber number;
  tasknamelength number; 
  
  BEGIN
    tasknamelength := LENGTH(taskName);
    
    WITH cte (task_number, rn, maxi) as(
       SELECT 
          CAST(SUBSTR(Task_Name,tasknamelength+1,2147483647) as number),
          row_number() over(order by CAST(SUBSTR(Task_Name,tasknamelength+1,2147483647) as number)),
          max(CAST(SUBSTR(Task_Name,tasknamelength+1,2147483647) as number)) over()
        FROM "&1".PROJECT_WCTASKS 
        WHERE
          Project_ID = projectID AND 
		  (Deleted)=0 AND 
		  (UPPER(SUBSTR(Task_Name,1,tasknamelength)))= UPPER(taskName) AND 
		   REGEXP_LIKE(SUBSTR(Task_Name,tasknamelength+1,2147483647),'^[0-9]*$') 
    )
    select 
      MIN(
         case 
	        when task_number != rn then rn
	        when task_number = maxi then task_number +1 
	      end
      ) into nextNumber
    from cte;
    
    RETURN(nextNumber); 
  END;
/

/* Function to check if the user is active based on 'Active_Until' column value. 
 * Returns 1 if the user is active, 0 otherwise.
 */
CREATE OR REPLACE FUNCTION "&1".is_user_active(activeUntil DATE)
	RETURN NUMBER
	IS
	BEGIN
		IF (activeUntil IS null) or (activeUntil > SYSDATE) THEN
			RETURN(1);
		END IF;
		
		RETURN (0);	
	END; 
/

spool off                    
disconnect
exit